//---------------------------------------------------------------------------
//		Copyright (C) 1991-93, Microsoft Corporation
//
// You have a royalty-free right to use, modify, reproduce and distribute
// the Sample Custom Control Files (and/or any modified version) in any way
// you find useful, provided that you agree that Microsoft has no warranty,
// obligation or liability for any Custom Control File.
//---------------------------------------------------------------------------
// pump.h
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Resource Information
//---------------------------------------------------------------------------
// Toolbox bitmap resource IDs numbers.
//---------------------------------------------------------------------------
#define IDBMP_PUMP			8000
#define IDBMP_PUMPDOWN		8001
#define IDBMP_PUMPMONO		8003
#define IDBMP_PUMPEGA 		8006

//---------------------------------------------------------------------------
// Change these for each new VBX file
//---------------------------------------------------------------------------
#define VBX_COMPANYNAME 	   	"Edward B. Toupin\0"
#define VBX_FILEDESCRIPTION	   "Visual Basic Pump Custom Control\0"
#define VBX_INTERNALNAME	   	"PUMP\0"
#define VBX_LEGALCOPYRIGHT	   	"Copyright \251 Edward B. Toupin 1994\0"
#define VBX_LEGALTRADEMARKS	   "Microsoft\256 is a registered trademark of Microsoft Corporation. Visual Basic\231 is a trademark of Microsoft Corporation. Windows\231 is a trademark of Microsoft Corporation.\0"
#define VBX_ORIGINALFILENAME	   "PUMP.VBX\0"
#define VBX_PRODUCTNAME 	   	"Microsoft\256 Visual Basic\231 for Windows\231\0"

//---------------------------------------------------------------------------
// Update these fields for each build.
//---------------------------------------------------------------------------
#define VBX_VERSION		    3,00,0,00
#define VBX_VERSION_STR 	   "3.00.000\0"

//---------------------------------------------------------------------------
// Constants used by dialog boxes
//---------------------------------------------------------------------------
#define DI_OK	      1
#define DI_CANCEL     2
#define DI_REDOPT     105
#define DI_GREENOPT   106
#define DI_BLUEOPT    107

#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Macro for referencing member of structure
//---------------------------------------------------------------------------
#define OFFSETIN(struc, field)	    ((USHORT)&(((struc *)0)->field))


//---------------------------------------------------------------------------
// Control and Window Procedures
//---------------------------------------------------------------------------
LONG FAR PASCAL _export PumpCtlProc(HCTL, HWND, USHORT, USHORT, LONG);
LONG FAR PASCAL _export FlashPopupWndProc(HWND hwnd, USHORT msg, USHORT wp, LONG lp);


//---------------------------------------------------------------------------
// Global Variables and Constants
//---------------------------------------------------------------------------
extern	HANDLE hmodDLL;     // From ccinit.c
#define CLASS_FLASHPOPUP    "FCPopup"


//---------------------------------------------------------------------------
// CIRCLE control data and structs
//---------------------------------------------------------------------------
typedef struct tagPUMP
    {
    RECT    rectDrawInto;
	ENUM    PumpState;    // Changed from SHORT to demonstrate ENUM prop
	LONG    FlashColor;
	HFONT   hfont;
    HSZ     hszCaption;
	} PUMP;

typedef PUMP FAR * LPPUMP;

#define LppumpDEREF(hctl)     ((LPPUMP)VBDerefControl(hctl))


//---------------------------------------------------------------------------
// Private messages
//---------------------------------------------------------------------------
#define CM_OPENFLASHDLG     WM_USER


//---------------------------------------------------------------------------
// Property info
//---------------------------------------------------------------------------
// List of enumeration for PumpShape ENUM property
#define STATE_OFF		0
#define STATE_ON		1
#define STATE_TRANS		2
#define STATE_ERROR		3
#define STATE_STRTING   4
#define STATE_STPING	5
#define STATE_MAX		5

PROPINFO Property_PumpState =
    {
	"PumpState",
    // Changed from SHORT to demonstrate an ENUM property
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSaveData,
	OFFSETIN(PUMP, PumpState),
	0,
	 STATE_OFF,
	 "0 - Off\0" "1 - On\0" "2 - Trans\0" "3 - Error\0" "4 - Starting\0" "5 - Stopping\0",
	 STATE_MAX
    };

PROPINFO Property_FlashColor =
    {
    "FlashColor",
    DT_COLOR | PF_fGetData | PF_fSetData | PF_fSaveData | PF_fEditable,
	 OFFSETIN(PUMP, FlashColor),
	0, 0, NULL, 0
    };

//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_PUMP_CTLNAME		  		 0
#define IPROP_PUMP_INDEX                1
#define IPROP_PUMP_BACKCOLOR            2
#define IPROP_PUMP_LEFT                 3
#define IPROP_PUMP_TOP                  4
#define IPROP_PUMP_WIDTH                5
#define IPROP_PUMP_HEIGHT               6
#define IPROP_PUMP_VISIBLE              7
#define IPROP_PUMP_PARENT               8
#define IPROP_PUMP_DRAGMODE             9
#define IPROP_PUMP_DRAGICON            10
#define IPROP_PUMP_TAG                 11
#define IPROP_PUMP_STATE         		12
#define IPROP_PUMP_FLASHCOLOR          13
#define IPROP_PUMP_CAPTION             14
#define IPROP_PUMP_FONTNAME            15
#define IPROP_PUMP_FONTBOLD            16
#define IPROP_PUMP_FONTITALIC          17
#define IPROP_PUMP_FONTSTRIKE          18
#define IPROP_PUMP_FONTUNDER           19
#define IPROP_PUMP_FONTSIZE            20
#define IPROP_PUMP_BORDERSTYLE	 		21
#define IPROP_PUMP_TABINDEX		 	22
#define IPROP_PUMP_TABSTOP		 		23
#define IPROP_PUMP_ENABLED		 		24
#define IPROP_PUMP_MOUSEPOINTER	 	25
#define IPROP_PUMP_HWND            	26
#define IPROP_PUMP_HELPCONTEXTID   	27
#define IPROP_PUMP_DATASOURCE      	28
#define IPROP_PUMP_DATAFIELD       	29
#define IPROP_PUMP_DATACHANGED     	30

PPROPINFO Pump_Properties[] =
    {
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
    PPROPINFO_STD_TAG,
	&Property_PumpState,
	&Property_FlashColor,
	PPROPINFO_STD_CAPTION,
    PPROPINFO_STD_FONTNAME,
    PPROPINFO_STD_FONTBOLD,
    PPROPINFO_STD_FONTITALIC,
    PPROPINFO_STD_FONTSTRIKE,
    PPROPINFO_STD_FONTUNDER,
    PPROPINFO_STD_FONTSIZE,
    PPROPINFO_STD_BORDERSTYLEOFF,
    PPROPINFO_STD_TABINDEX,
    PPROPINFO_STD_TABSTOP,
    PPROPINFO_STD_ENABLED,
    PPROPINFO_STD_MOUSEPOINTER,
    PPROPINFO_STD_HWND,
    PPROPINFO_STD_HELPCONTEXTID,
    PPROPINFO_STD_DATASOURCE,
    PPROPINFO_STD_DATAFIELD,
	PPROPINFO_STD_DATACHANGED,
	NULL
    };


//---------------------------------------------------------------------------
// Event info
//---------------------------------------------------------------------------
WORD Paramtypes_ClickIn[] = {ET_R4, ET_R4, ET_SD};

EVENTINFO Event_ClickIn =
    {
	"ClickIn",3,6,Paramtypes_ClickIn,
    "X As Single,Y As Single,Caption As String"
    };

EVENTINFO Event_ClickOut =
    {
	"ClickOut",0,0,NULL,NULL
	};


//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
#define IEVENT_PUMP_CLICKIN		  0
#define IEVENT_PUMP_CLICKOUT		  1
#define IEVENT_PUMP_DRAGDROP		  2
#define IEVENT_PUMP_DRAGOVER		  3

PEVENTINFO Pump_Events[] =
    {
	&Event_ClickIn,&Event_ClickOut,PEVENTINFO_STD_DRAGDROP,
	PEVENTINFO_STD_DRAGOVER,NULL
    };


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
MODEL modelPump =
    {
    VB_VERSION, 			// VB version being used
    MODEL_fFocusOk | MODEL_fLoadMsg,			// MODEL flags
	(PCTLPROC)PumpCtlProc,		// Control procedure
    CS_VREDRAW | CS_HREDRAW,		// Class style
    0L, 				// Default Windows style
	sizeof(PUMP),			// Size of PUMP structure
	IDBMP_PUMP,			// Palette bitmap ID
	"Pump",				// Default control name
	"PUMP",				// Visual Basic class name
    NULL,				// Parent class name
	Pump_Properties,			// Property information table
	Pump_Events,			// Event information table
	IPROP_PUMP_STATE,		// Default property
	IEVENT_PUMP_CLICKIN,		// Default event
	IPROP_PUMP_STATE		// Property representing value of ctl
    };

LPMODEL modellistPump[] =
    {
	&modelPump,
    NULL
    };

MODELINFO modelinfoPump =
    {
    VB_VERSION, 			// VB version being used
	modellistPump			// MODEL list
    };

#endif	// RC_INVOKED

//---------------------------------------------------------------------------
